Add KEY_MICMUTE and enable it on Lenovo X220
[linux-2.6/linux-acpi-2.6/ibm-acpi-2.6.git] / scripts / decodecode
blob18ba881c34159a8bcdc3b8b582bd3f0617f90e8a
1 #!/bin/sh
2 # Disassemble the Code: line in Linux oopses
3 # usage: decodecode < oops.file
5 # options: set env. variable AFLAGS=options to pass options to "as";
6 # e.g., to decode an i386 oops on an x86_64 system, use:
7 # AFLAGS=--32 decodecode < 386.oops
9 cleanup() {
10 rm -f $T $T.s $T.o $T.oo $T.aa $T.dis
11 exit 1
14 die() {
15 echo "$@"
16 exit 1
19 trap cleanup EXIT
21 T=`mktemp` || die "cannot create temp file"
22 code=
24 while read i ; do
26 case "$i" in
27 *Code:*)
28 code=$i
30 esac
32 done
34 if [ -z "$code" ]; then
35 rm $T
36 exit
39 echo $code
40 code=`echo $code | sed -e 's/.*Code: //'`
42 width=`expr index "$code" ' '`
43 width=$((($width-1)/2))
44 case $width in
45 1) type=byte ;;
46 2) type=2byte ;;
47 4) type=4byte ;;
48 esac
50 disas() {
51 ${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1
53 if [ "$ARCH" = "arm" ]; then
54 if [ $width -eq 2 ]; then
55 OBJDUMPFLAGS="-M force-thumb"
58 ${CROSS_COMPILE}strip $1.o
61 ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \
62 grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1
65 marker=`expr index "$code" "\<"`
66 if [ $marker -eq 0 ]; then
67 marker=`expr index "$code" "\("`
70 touch $T.oo
71 if [ $marker -ne 0 ]; then
72 echo All code >> $T.oo
73 echo ======== >> $T.oo
74 beforemark=`echo "$code"`
75 echo -n " .$type 0x" > $T.s
76 echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s
77 disas $T
78 cat $T.dis >> $T.oo
79 rm -f $T.o $T.s $T.dis
81 # and fix code at-and-after marker
82 code=`echo "$code" | cut -c$((${marker} + 1))-`
84 echo Code starting with the faulting instruction > $T.aa
85 echo =========================================== >> $T.aa
86 code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'`
87 echo -n " .$type 0x" > $T.s
88 echo $code >> $T.s
89 disas $T
90 cat $T.dis >> $T.aa
92 faultline=`cat $T.dis | head -1 | cut -d":" -f2`
93 faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'`
95 cat $T.oo | sed -e "s/\($faultline\)/\*\1 <-- trapping instruction/g"
96 echo
97 cat $T.aa
98 cleanup